## arachne-pnr 0~20150927gitefdb026

=== Makefile ===

# build with default C/C++ compiler
# CC = clang
# CXX = clang++

# build optimized without -DNDEBUG
# OPTDEBUGFLAGS = -O0 -fno-inline -g
OPTDEBUGFLAGS = -O2 # -DNDEBUG
SRC = src

# clang only: -Wglobal-constructors
CXXFLAGS = -I$(SRC) -std=c++11 -MD $(OPTDEBUGFLAGS) -Wall -Wshadow -Wsign-compare -Werror
LIBS = -lm

DESTDIR = /usr/local
ICEBOX = /usr/local/share/icebox

.PHONY: all
all: bin/arachne-pnr share/arachne-pnr/chipdb-1k.bin share/arachne-pnr/chipdb-8k.bin

bin/arachne-pnr: src/arachne-pnr.o src/netlist.o src/blif.o src/pack.o src/place.o src/util.o src/io.o src/route.o src/chipdb.o src/location.o src/configuration.o src/line_parser.o src/pcf.o src/global.o src/constant.o src/designstate.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)

share/arachne-pnr/chipdb-1k.bin: bin/arachne-pnr $(ICEBOX)/chipdb-1k.txt
	mkdir -p share/arachne-pnr
	bin/arachne-pnr -d 1k -c $(ICEBOX)/chipdb-1k.txt --write-binary-chipdb share/arachne-pnr/chipdb-1k.bin

share/arachne-pnr/chipdb-8k.bin: bin/arachne-pnr $(ICEBOX)/chipdb-8k.txt
	mkdir -p share/arachne-pnr
	bin/arachne-pnr -d 8k -c $(ICEBOX)/chipdb-8k.txt --write-binary-chipdb share/arachne-pnr/chipdb-8k.bin

tests/test_bv: tests/test_bv.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $^

tests/test_us: tests/test_us.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $^

# assumes icestorm installed
simpletest: all tests/test_bv tests/test_us
	./tests/test_bv
	./tests/test_us
	cd tests/simple && ICEBOX=$(ICEBOX) bash run-test.sh
	cd tests/regression && bash run-test.sh
	@echo
	@echo 'All tests passed.'
	@echo

# assumes icestorm, yosys installed
test: all tests/test_bv ./tests/test_us
	./tests/test_bv
	./tests/test_us
	make -C examples/rot clean && make -C examples/rot
	cd tests/simple && ICEBOX=$(ICEBOX) bash run-test.sh
	cd tests/regression && bash run-test.sh
	cd tests/fsm && bash run-test.sh
	cd tests/combinatorial && bash run-test.sh
	@echo
	@echo 'All tests passed.'
	@echo

# assumes valgrind installed
testvg:
	cd tests/simple && bash run-valgrind-test.sh
	@echo
	@echo 'All tests passed.'
	@echo

-include src/*.d

.PHONY: install
install: all
	mkdir -p $(DESTDIR)/bin
	cp bin/arachne-pnr $(DESTDIR)/bin/arachne-pnr
	mkdir -p $(DESTDIR)/share/arachne-pnr
	cp share/arachne-pnr/chipdb-1k.bin $(DESTDIR)/share/arachne-pnr/chipdb-1k.bin
	cp share/arachne-pnr/chipdb-8k.bin $(DESTDIR)/share/arachne-pnr/chipdb-8k.bin

.PHONY: uninstall
uninstall:
	rm -f $(DESTDIR)/bin/arachne-pnr
	rm -f $(DESTDIR)/bin/share/arachne-pnr/*.bin

.PHONY: clean
clean:
	rm -f src/*.o tests/*.o src/*.d tests/*.d bin/arachne-pnr tests/test_bv
	rm -f share/arachne-pnr/*.bin

=== debian/changelog ===
arachne-pnr (0~20150927gitefdb026-1) unstable; urgency=low

  * Initial release (Closes: #801230)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Mon, 16 Nov 2015 20:49:20 +0100

=== debian/control ===
Source: arachne-pnr
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ruben Undheim <ruben.undheim@gmail.com>
Section: electronics
Priority: optional
Build-Depends: debhelper (>= 9),
               fpga-icestorm-chipdb,
               txt2man
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/arachne-pnr.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/arachne-pnr.git
Homepage: https://github.com/cseed/arachne-pnr

Package: arachne-pnr-chipdb
Architecture: all
Depends: ${misc:Depends}
Description: Chip db files for arachne-pnr
 Arachne-pnr implements the place and route step of the hardware compilation
 process for FPGAs. It accepts as input a technology-mapped netlist in BLIF
 format, as output by the Yosys synthesis suite for example. It currently
 targets the Lattice Semiconductor iCE40 family of FPGAs. Its output is a
 textual bitstream representation for assembly by the IceStorm icepack command.
 The output of icepack is a binary bitstream which can be uploaded to a harware
 device.
 .
 This package contains the binary versions of the chipdb files needed by
 arachne-pnr

Package: arachne-pnr
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         arachne-pnr-chipdb,
         yosys,
         fpga-icestorm
Description: Place and route tool for iCE40 family FGPAs
 Arachne-pnr implements the place and route step of the hardware compilation
 process for FPGAs. It accepts as input a technology-mapped netlist in BLIF
 format, as output by the Yosys synthesis suite for example. It currently
 targets the Lattice Semiconductor iCE40 family of FPGAs. Its output is a
 textual bitstream representation for assembly by the IceStorm icepack command.
 The output of icepack is a binary bitstream which can be uploaded to a harware
 device.
 .
 Together, Yosys, arachne-pnr and IceStorm provide an fully open-source
 Verilog-to-bistream tool chain for iCE40 1K and 8K FPGA development.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CHANGELOG_DATE ?= $(shell date -d "`dpkg-parsechangelog --show-field Date`" +"%d %B %Y")

%:
	dh $@ 

override_dh_auto_clean:
	dh_auto_clean
	$(RM) debian/man/*.1
	$(RM) -f share/

override_dh_installman:
	cd debian/man ; CHANGELOG_DATE="$(CHANGELOG_DATE)" ./genmanpages.sh
	dh_installman

## arachne-pnr 0.1%2B20160813git52e69ed

=== debian/changelog ===
arachne-pnr (0.1+20160813git52e69ed-1) unstable; urgency=low

  * New upstream version
  * debian/man/arachne-pnr.txt: Describe new command line switch
  * debian/patches/0006-Fixed-spelling.patch: Fixed minor spelling error
  * debian/control:
    - New standards 3.9.8 - no changes
    - Fixed spelling error in description
  * Patches now being generated by gbp pq

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 23 Sep 2016 06:59:03 +0200

arachne-pnr (0.1+20151224git1a4fdf9-1) unstable; urgency=medium

  * New upstream version
    - Fixes FTBFS (Closes: #816579)
  * d/rules: Minor typo fix
  * d/patches/05_prevent_dependency_on_git.patch:
    - Set VER and GIT_REV explicitly

 -- Ruben Undheim <ruben.undheim@gmail.com>  Thu, 03 Mar 2016 23:55:14 +0100

arachne-pnr (0~20150927gitefdb026-2) unstable; urgency=medium

  [ Eduard Sanou ]
  * Set changelog date to UTC with LC_ALL=C to make man pages reproducible.
    (Closes: #815082)

  [ Ruben Undheim ]
  * d/control:
    - Fix typo in short description. (Closes: #814370)
    - Standards to 3.9.7 - no needed changes
  * d/copyright: Updated copyright years

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 19 Feb 2016 17:37:07 +0100

## arachne-pnr 0.1+20151224git1a4fdf9

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,15 @@
 .PHONY: all
 all: bin/arachne-pnr share/arachne-pnr/chipdb-1k.bin share/arachne-pnr/chipdb-8k.bin
 
-bin/arachne-pnr: src/arachne-pnr.o src/netlist.o src/blif.o src/pack.o src/place.o src/util.o src/io.o src/route.o src/chipdb.o src/location.o src/configuration.o src/line_parser.o src/pcf.o src/global.o src/constant.o src/designstate.o
+VER = 0.1+$(shell echo `git log --oneline | wc -l`)+$(shell echo `git diff --name-only HEAD | wc -l`)
+GIT_REV = $(shell git rev-parse --verify --short HEAD)
+
+VER_HASH = $(shell echo "$(VER) $(GIT_REV)" | sum | cut -d ' ' -f -1)
+
+src/version_$(VER_HASH).cc:
+	echo "const char *version_str = \"arachne-pnr $(VER) (git sha1 $(GIT_REV), $(notdir $(CXX)) `$(CXX) --version | tr ' ()' '\n' | grep '^[0-9]' | head -n1` $(filter -f% -m% -O% -DNDEBUG,$(CXXFLAGS)))\";" > src/version_$(VER_HASH).cc
+
+bin/arachne-pnr: src/arachne-pnr.o src/netlist.o src/blif.o src/pack.o src/place.o src/util.o src/io.o src/route.o src/chipdb.o src/location.o src/configuration.o src/line_parser.o src/pcf.o src/global.o src/constant.o src/designstate.o src/version_$(VER_HASH).o
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)
 
 share/arachne-pnr/chipdb-1k.bin: bin/arachne-pnr $(ICEBOX)/chipdb-1k.txt
@@ -41,6 +49,8 @@
 	./tests/test_us
 	cd tests/simple && ICEBOX=$(ICEBOX) bash run-test.sh
 	cd tests/regression && bash run-test.sh
+	cd tests/blif && bash run-test.sh
+	cd tests/error && bash run-test.sh
 	@echo
 	@echo 'All tests passed.'
 	@echo
@@ -52,6 +62,8 @@
 	make -C examples/rot clean && make -C examples/rot
 	cd tests/simple && ICEBOX=$(ICEBOX) bash run-test.sh
 	cd tests/regression && bash run-test.sh
+	cd tests/blif && bash run-test.sh
+	cd tests/error && bash run-test.sh
 	cd tests/fsm && bash run-test.sh
 	cd tests/combinatorial && bash run-test.sh
 	@echo
@@ -64,6 +76,12 @@
 	@echo
 	@echo 'All tests passed.'
 	@echo
+
+fuzz-pcf: all
+	afl-fuzz -t 2500 -m 500 -x fuzz/pcf/pcf.dict -i fuzz/pcf/testcases -o fuzz/pcf/findings bin/arachne-pnr -p @@ fuzz/pcf/rot.blif -o /dev/null
+
+fuzz-blif: all
+	afl-fuzz -t 2500 -m 500 -x fuzz/blif/blif.dict -i fuzz/blif/testcases -o fuzz/blif/findings bin/arachne-pnr @@ -o /dev/null
 
 -include src/*.d
 
@@ -82,5 +100,7 @@
 
 .PHONY: clean
 clean:
-	rm -f src/*.o tests/*.o src/*.d tests/*.d bin/arachne-pnr tests/test_bv
+	rm -f src/*.o tests/*.o src/*.d tests/*.d bin/arachne-pnr
+	rm -f tests/test_bv tests/test_us
 	rm -f share/arachne-pnr/*.bin
+	rm -f src/version_*

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper (>= 9),
                fpga-icestorm-chipdb,
                txt2man
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/arachne-pnr.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/arachne-pnr.git
 Homepage: https://github.com/cseed/arachne-pnr
@@ -33,7 +33,7 @@
          arachne-pnr-chipdb,
          yosys,
          fpga-icestorm
-Description: Place and route tool for iCE40 family FGPAs
+Description: Place and route tool for iCE40 family FPGAs
  Arachne-pnr implements the place and route step of the hardware compilation
  process for FPGAs. It accepts as input a technology-mapped netlist in BLIF
  format, as output by the Yosys synthesis suite for example. It currently

## arachne-pnr 0.1+20160813git52e69ed

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,8 @@
 
 # build optimized without -DNDEBUG
 # OPTDEBUGFLAGS = -O0 -fno-inline -g
-OPTDEBUGFLAGS = -O2 # -DNDEBUG
+# OPTDEBUGFLAGS = -O3 -DNDEBUG
+OPTDEBUGFLAGS = -O2
 SRC = src
 
 # clang only: -Wglobal-constructors
@@ -85,6 +86,22 @@
 
 -include src/*.d
 
+.PHONY: mxebin
+mxebin:
+	$(MAKE) clean
+	rm -rf arachne-pnr-win32
+	rm -f arachne-pnr-win32.zip
+	mkdir -p arachne-pnr-win32
+	$(MAKE) share/arachne-pnr/chipdb-1k.bin share/arachne-pnr/chipdb-8k.bin
+	mv share/arachne-pnr/chipdb-1k.bin arachne-pnr-win32/
+	mv share/arachne-pnr/chipdb-8k.bin arachne-pnr-win32/
+	$(MAKE) clean
+	$(MAKE) CC=/usr/local/src/mxe/usr/bin/i686-w64-mingw32.static-gcc CXX=/usr/local/src/mxe/usr/bin/i686-w64-mingw32.static-g++ bin/arachne-pnr
+	mv bin/arachne-pnr arachne-pnr-win32/arachne-pnr.exe
+	zip -r arachne-pnr-win32.zip arachne-pnr-win32/
+	rm -rf arachne-pnr-win32
+	$(MAKE) clean
+
 .PHONY: install
 install: all
 	mkdir -p $(DESTDIR)/bin

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper (>= 9),
                fpga-icestorm-chipdb,
                txt2man
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/arachne-pnr.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/arachne-pnr.git
 Homepage: https://github.com/cseed/arachne-pnr
@@ -20,7 +20,7 @@
  format, as output by the Yosys synthesis suite for example. It currently
  targets the Lattice Semiconductor iCE40 family of FPGAs. Its output is a
  textual bitstream representation for assembly by the IceStorm icepack command.
- The output of icepack is a binary bitstream which can be uploaded to a harware
+ The output of icepack is a binary bitstream which can be uploaded to a hardware
  device.
  .
  This package contains the binary versions of the chipdb files needed by
@@ -39,7 +39,7 @@
  format, as output by the Yosys synthesis suite for example. It currently
  targets the Lattice Semiconductor iCE40 family of FPGAs. Its output is a
  textual bitstream representation for assembly by the IceStorm icepack command.
- The output of icepack is a binary bitstream which can be uploaded to a harware
+ The output of icepack is a binary bitstream which can be uploaded to a hardware
  device.
  .
  Together, Yosys, arachne-pnr and IceStorm provide an fully open-source

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d "`dpkg-parsechangelog --show-field Date`" +"%d %B %Y")

%:
	dh $@ 

override_dh_auto_clean:
	dh_auto_clean
	$(RM) debian/man/*.1
	$(RM) -r share/

override_dh_installman:
	cd debian/man ; CHANGELOG_DATE="$(CHANGELOG_DATE)" ./genmanpages.sh
	dh_installman

=== debian/watch ===
version=3
https://github.com/cseed/arachne-pnr/releases /cseed/arachne-pnr/archive/\w+-(\d\S+)\.tar\.(?:bz2|gz|xz)

## arachne-pnr 0.1+20180513git5d830dd

=== Makefile ===

# build with default C/C++ compiler
# CC = clang
# CXX = clang++

# build optimized without -DNDEBUG
# OPTDEBUGFLAGS = -O0 -fno-inline -g
# OPTDEBUGFLAGS = -O3 -DNDEBUG
OPTDEBUGFLAGS ?= -MD -O2
SRC = src

# clang only: -Wglobal-constructors
CXXFLAGS += -I$(SRC) -std=c++11 $(OPTDEBUGFLAGS) -Wall -Wshadow -Wsign-compare -Werror
LIBS = -lm

DESTDIR ?=
PREFIX ?= /usr/local
ICEBOX ?= $(PREFIX)/share/icebox

# Cross-compile logic
HOST_CC ?= $(CC)
HOST_CXX ?= $(CXX)
HOST_CXXFLAGS += -I$(SRC) -std=c++11 $(OPTDEBUGFLAGS) -Wall -Wshadow -Wsign-compare -Werror
HOST_LIBS ?= $(LIBS)

IS_CROSS_COMPILING = no
ifneq ($(CC),$(HOST_CC))
	IS_CROSS_COMPILING = yes
endif
ifneq ($(CXX),$(HOST_CXX))
	IS_CROSS_COMPILING = yes
endif

.PHONY: all
all: bin/arachne-pnr$(EXE) share/arachne-pnr/chipdb-384.bin share/arachne-pnr/chipdb-1k.bin share/arachne-pnr/chipdb-8k.bin share/arachne-pnr/chipdb-5k.bin share/arachne-pnr/chipdb-lm4k.bin

ARACHNE_VER = 0.1+$(shell test -e .git && echo `git log --oneline | wc -l`+`git diff --name-only HEAD | wc -l`)
GIT_REV = $(shell git rev-parse --verify --short HEAD 2>/dev/null || echo UNKNOWN)

VER_HASH = $(shell echo "$(ARACHNE_VER) $(GIT_REV)" | sum | cut -d ' ' -f -1)

src/version_$(VER_HASH).cc:
	echo "const char *version_str = \"arachne-pnr $(ARACHNE_VER) (git sha1 $(GIT_REV), $(notdir $(CXX)) `$(CXX) --version | tr ' ()' '\n' | grep '^[0-9]' | head -n1` $(filter -f% -m% -O% -DNDEBUG,$(CXXFLAGS)))\";" > src/version_$(VER_HASH).cc

bin/arachne-pnr$(EXE): src/arachne-pnr.o src/netlist.o src/blif.o src/pack.o src/place.o src/util.o src/io.o src/route.o src/chipdb.o src/location.o src/configuration.o src/line_parser.o src/pcf.o src/global.o src/constant.o src/designstate.o src/version_$(VER_HASH).o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)

ifeq ($(IS_CROSS_COMPILING),yes)
bin/arachne-pnr-host: src/arachne-pnr.host-o src/netlist.host-o src/blif.host-o src/pack.host-o src/place.host-o src/util.host-o src/io.host-o src/route.host-o src/chipdb.host-o src/location.host-o src/configuration.host-o src/line_parser.host-o src/pcf.host-o src/global.host-o src/constant.host-o src/designstate.host-o src/version_$(VER_HASH).host-o
	$(HOST_CXX) $(HOST_CXXFLAGS) $(HOST_LDFLAGS) -o $@ $^ $(HOST_LIBS)
else
bin/arachne-pnr-host: bin/arachne-pnr$(EXE)
	cp $< $@
endif

%.host-o: %.cc
	$(HOST_CXX) -c $(HOST_CPPFLAGS) $(HOST_CXXFLAGS) -o $@ $<

ifeq ($(EXE),.js)
# Special hack to make sure chipdb is built first
bin/arachne-pnr$(EXE): | share/arachne-pnr/chipdb-384.bin share/arachne-pnr/chipdb-1k.bin share/arachne-pnr/chipdb-8k.bin share/arachne-pnr/chipdb-5k.bin
endif

share/arachne-pnr/chipdb-384.bin: bin/arachne-pnr-host $(ICEBOX)/chipdb-384.txt
	mkdir -p share/arachne-pnr
	./bin/arachne-pnr-host -d 384 -c $(ICEBOX)/chipdb-384.txt --write-binary-chipdb share/arachne-pnr/chipdb-384.bin

share/arachne-pnr/chipdb-1k.bin: bin/arachne-pnr-host $(ICEBOX)/chipdb-1k.txt
	mkdir -p share/arachne-pnr
	./bin/arachne-pnr-host -d 1k -c $(ICEBOX)/chipdb-1k.txt --write-binary-chipdb share/arachne-pnr/chipdb-1k.bin

share/arachne-pnr/chipdb-8k.bin: bin/arachne-pnr-host $(ICEBOX)/chipdb-8k.txt
	mkdir -p share/arachne-pnr
	./bin/arachne-pnr-host -d 8k -c $(ICEBOX)/chipdb-8k.txt --write-binary-chipdb share/arachne-pnr/chipdb-8k.bin

share/arachne-pnr/chipdb-5k.bin: bin/arachne-pnr-host $(ICEBOX)/chipdb-5k.txt
	mkdir -p share/arachne-pnr
	./bin/arachne-pnr-host -d 8k -c $(ICEBOX)/chipdb-5k.txt --write-binary-chipdb share/arachne-pnr/chipdb-5k.bin

share/arachne-pnr/chipdb-lm4k.bin: bin/arachne-pnr-host $(ICEBOX)/chipdb-lm4k.txt
	mkdir -p share/arachne-pnr
	./bin/arachne-pnr-host -d 8k -c $(ICEBOX)/chipdb-lm4k.txt --write-binary-chipdb share/arachne-pnr/chipdb-lm4k.bin

tests/test_bv: tests/test_bv.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $^

tests/test_us: tests/test_us.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $^

# assumes icestorm installed
simpletest: all tests/test_bv tests/test_us
	./tests/test_bv
	./tests/test_us
	cd tests/simple && ICEBOX=$(ICEBOX) bash run-test.sh
	cd tests/io && bash run-test.sh
	cd tests/regression && bash run-test.sh
	cd tests/blif && bash run-test.sh
	cd tests/error && bash run-test.sh
	@echo
	@echo 'All tests passed.'
	@echo

# assumes icestorm, yosys installed
test: all tests/test_bv ./tests/test_us
	./tests/test_bv
	./tests/test_us
	make -C examples/rot clean && make -C examples/rot
	cd tests/simple && ICEBOX=$(ICEBOX) bash run-test.sh
	cd tests/io && bash run-test.sh
	cd tests/regression && bash run-test.sh
	cd tests/blif && bash run-test.sh
	cd tests/error && bash run-test.sh
	cd tests/fsm && bash run-test.sh
	cd tests/combinatorial && bash run-test.sh
	@echo
	@echo 'All tests passed.'
	@echo

# assumes valgrind installed
testvg:
	cd tests/simple && bash run-valgrind-test.sh
	@echo
	@echo 'All tests passed.'
	@echo

fuzz-pcf: all
	afl-fuzz -t 2500 -m 500 -x fuzz/pcf/pcf.dict -i fuzz/pcf/testcases -o fuzz/pcf/findings bin/arachne-pnr -p @@ fuzz/pcf/rot.blif -o /dev/null

fuzz-blif: all
	afl-fuzz -t 2500 -m 500 -x fuzz/blif/blif.dict -i fuzz/blif/testcases -o fuzz/blif/findings bin/arachne-pnr @@ -o /dev/null

-include src/*.d

.PHONY: mxebin
mxebin:
	$(MAKE) clean
	rm -rf arachne-pnr-win32
	rm -f arachne-pnr-win32.zip
	mkdir -p arachne-pnr-win32
	$(MAKE) share/arachne-pnr/chipdb-384.bin share/arachne-pnr/chipdb-1k.bin share/arachne-pnr/chipdb-8k.bin
	mv share/arachne-pnr/chipdb-384.bin arachne-pnr-win32/
	mv share/arachne-pnr/chipdb-1k.bin arachne-pnr-win32/
	mv share/arachne-pnr/chipdb-8k.bin arachne-pnr-win32/
	mv share/arachne-pnr/chipdb-5k.bin arachne-pnr-win32/
	mv share/arachne-pnr/chipdb-lm4k.bin arachne-pnr-win32/
	$(MAKE) clean
	$(MAKE) CC=/usr/local/src/mxe/usr/bin/i686-w64-mingw32.static-gcc CXX=/usr/local/src/mxe/usr/bin/i686-w64-mingw32.static-g++ CXXFLAGS="$(CXXFLAGS) -DMXE_DIR_STRUCTURE" bin/arachne-pnr
	mv bin/arachne-pnr arachne-pnr-win32/arachne-pnr.exe
	zip -r arachne-pnr-win32.zip arachne-pnr-win32/
	rm -rf arachne-pnr-win32
	$(MAKE) clean

.PHONY: install
install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp bin/arachne-pnr$(EXE) $(DESTDIR)$(PREFIX)/bin/arachne-pnr$(EXE)
	mkdir -p $(DESTDIR)$(PREFIX)/share/arachne-pnr
	cp share/arachne-pnr/chipdb-384.bin $(DESTDIR)$(PREFIX)/share/arachne-pnr/chipdb-384.bin
	cp share/arachne-pnr/chipdb-1k.bin $(DESTDIR)$(PREFIX)/share/arachne-pnr/chipdb-1k.bin
	cp share/arachne-pnr/chipdb-8k.bin $(DESTDIR)$(PREFIX)/share/arachne-pnr/chipdb-8k.bin
	cp share/arachne-pnr/chipdb-5k.bin $(DESTDIR)$(PREFIX)/share/arachne-pnr/chipdb-5k.bin
	cp share/arachne-pnr/chipdb-lm4k.bin $(DESTDIR)$(PREFIX)/share/arachne-pnr/chipdb-lm4k.bin

.PHONY: uninstall
uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/arachne-pnr$(EXE)
	rm -f $(DESTDIR)$(PREFIX)/share/arachne-pnr/*.bin

.PHONY: clean
clean:
	rm -f src/*.o src/*.host-o tests/*.o src/*.d tests/*.d bin/arachne-pnr$(EXE) bin/arachne-pnr-host
	rm -f tests/test_bv tests/test_us
	rm -f share/arachne-pnr/*.bin
	rm -f src/version_*
	$(MAKE) -C examples/rot clean
	rm -rf tests/combinatorial/temp tests/combinatorial/1k tests/combinatorial/8k
	rm -rf tests/fsm/temp tests/fsm/1k tests/fsm/8k
	rm -rf tests/regression/1k tests/regression/8k
	rm -rf tests/simple/txt.sum tests/simple/1k tests/simple/8k

.PHONY: emcc
emcc:
	$(MAKE) EXE=.js clean
	$(MAKE) CC=emcc CXX=emcc HOST_CC=gcc HOST_CXX=g++ PREFIX=/ LDFLAGS="--memory-init-file 0 --embed-file share -s TOTAL_MEMORY=256*1024*1024" EXE=.js

=== debian/changelog ===
arachne-pnr (0.1+20180513git5d830dd-1ubuntu2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:33:20 +0100

arachne-pnr (0.1+20180513git5d830dd-1ubuntu1) cosmic; urgency=medium

  * Drop too strict version comparison.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 17 Jul 2018 13:33:32 +0100

arachne-pnr (0.1+20180513git5d830dd-1) unstable; urgency=medium

  * New upstream release
    - Refreshed patches. Dropped some applied upstream
  * debian/control:
    - Depend on newer version of fpga-icestorm-chipdb (>= 0~20180710git6a1bd78)
  * debian/copyright:
    - Main license for upstream project has changed from GPL-2 to MIT
    - Some files still at GPL-2. List them explicitly
  * debian/rules:
    - Replace dpkg-parsechangelog with /usr/share/dpkg/pkg-info.mk
    - Set some environment variables from debian/rules instead of having
      patches for them: ICEBOX, OPTDEBUGFLAGS and PREFIX

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 14 Jul 2018 10:01:51 +0200

arachne-pnr (0.1+20160813git52e69ed-2) unstable; urgency=medium

  * debian/compat: Change to 11
  * debian/control:
    - Change VCS URLs to salsa.debian.org
    - debhelper >= 11
    - New standards version 4.1.5 - no changes
    - Multi-Arch: foreign for arachne-pnr-chipdb
  * debian/patches/0007-Fix-IdLess-compilation-with-gcc8.patch
    - Fix FTBFS with GCC-8 (Closes: #897706)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Thu, 12 Jul 2018 20:52:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,20 @@
 Source: arachne-pnr
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ruben Undheim <ruben.undheim@gmail.com>
 Section: electronics
 Priority: optional
-Build-Depends: debhelper (>= 9),
-               fpga-icestorm-chipdb,
+Build-Depends: debhelper (>= 11),
+               fpga-icestorm-chipdb (>= 0~20180710git6a1bd78),
                txt2man
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/arachne-pnr.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/arachne-pnr.git
+Standards-Version: 4.1.5
+Vcs-Browser: https://salsa.debian.org/science-team/arachne-pnr
+Vcs-Git: https://salsa.debian.org/science-team/arachne-pnr.git
 Homepage: https://github.com/cseed/arachne-pnr
 
 Package: arachne-pnr-chipdb
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Chip db files for arachne-pnr
  Arachne-pnr implements the place and route step of the hardware compilation

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export PREFIX=/usr

CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d @$(SOURCE_DATE_EPOCH) +"%d %B %Y")

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	$(RM) debian/man/*.1
	$(RM) -r share/

override_dh_auto_build:
	OPTDEBUGFLAGS="-O2 -DNDEBUG" ICEBOX=/usr/share/fpga-icestorm/chipdb dh_auto_build

override_dh_auto_install:
	OPTDEBUGFLAGS="-O2 -DNDEBUG" ICEBOX=/usr/share/fpga-icestorm/chipdb dh_auto_install

override_dh_installman:
	cd debian/man ; CHANGELOG_DATE="$(CHANGELOG_DATE)" ./genmanpages.sh
	dh_installman

## arachne-pnr 0.1+20180827gitc00a141

=== debian/changelog ===
arachne-pnr (0.1+20180827gitc00a141-1) unstable; urgency=medium

  * New upstream release
    - Refreshed patches. Two patches dropped because they have been
      applied upstream.
  * debian/control: new standards version 4.2.1 - no changes
  * debian/upstream/metadata added
  * debian/watch:
    - Change so that it uses latest GIT HEAD directly since upstream
      does not make regular releases.

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 04 Sep 2018 21:06:33 +0200

arachne-pnr (0.1+20180513git5d830dd-3) unstable; urgency=medium

  * Fix lintian 'illegal-runtime-test-name' by renaming test from
    can_show_help to can-show-help.
  * debian/patches/0006-Do-not-add-all-the-flags-to-src-version_xx.c.patch
    - Show debian package version instead of a long string of build flags
      when running "arachne-pnr". This caused problems with version mismatch
      between arachne-pnr and arachne-pnr-chipdb. (Closes: #904144)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Mon, 30 Jul 2018 20:19:33 +0200

arachne-pnr (0.1+20180513git5d830dd-2) unstable; urgency=low

  * Upload to unstable
  * d/patches/debian/patches/0005-Fix-build-in-GNU-hurd.patch
    - Use dladdr to find path of executable in GNU hurd
  * debian/tests: Added simple autopkgtest for checking that the executable
    can be started

 -- Ruben Undheim <ruben.undheim@gmail.com>  Mon, 23 Jul 2018 22:16:16 +0200

arachne-pnr (0.1+20180513git5d830dd-2~exp1) experimental; urgency=medium

  * d/patches/0004-Check-for-macro-__FreeBSD_kernel__-in-order-to-solve.patch:
    - Check for macro __FreeBSD_kernel__ in order to attempt fixing FTBFS on
      kfreebsd-* (Closes: #903962)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 17 Jul 2018 16:16:37 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: arachne-pnr
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ruben Undheim <ruben.undheim@gmail.com>
 Section: electronics
 Priority: optional
 Build-Depends: debhelper (>= 11),
                fpga-icestorm-chipdb (>= 0~20180710git6a1bd78),
                txt2man
-Standards-Version: 4.1.5
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/science-team/arachne-pnr
 Vcs-Git: https://salsa.debian.org/science-team/arachne-pnr.git
 Homepage: https://github.com/cseed/arachne-pnr

## arachne-pnr 0.1+20180909git840bdfd

=== Makefile ===
--- 
+++ 
@@ -9,9 +9,20 @@
 OPTDEBUGFLAGS ?= -MD -O2
 SRC = src
 
+ifeq ($(OS),Windows_NT)
+    detected_OS := Windows
+else
+    detected_OS := $(shell sh -c 'uname -s 2>/dev/null || echo not')
+endif
+
 # clang only: -Wglobal-constructors
 CXXFLAGS += -I$(SRC) -std=c++11 $(OPTDEBUGFLAGS) -Wall -Wshadow -Wsign-compare -Werror
-LIBS = -lm
+
+ifeq ($(detected_OS),GNU)           # GNU Hurd
+	LIBS = -lm -ldl
+else
+	LIBS = -lm
+endif
 
 DESTDIR ?=
 PREFIX ?= /usr/local

=== debian/changelog ===
arachne-pnr (0.1+20180909git840bdfd-1) unstable; urgency=medium

  * New upstream version
  * debian/control:
    - Bump required build-dependency version of fpga-icestorm to
      '0~20181109git9671b76'

 -- Ruben Undheim <ruben.undheim@gmail.com>  Thu, 20 Dec 2018 11:28:31 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Section: electronics
 Priority: optional
 Build-Depends: debhelper (>= 11),
-               fpga-icestorm-chipdb (>= 0~20180710git6a1bd78),
+               fpga-icestorm-chipdb (>= 0~20181109git9671b76),
                txt2man
 Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/science-team/arachne-pnr

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,8 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 export PREFIX=/usr
+
+export DEBIAN_VER=$(DEB_VERSION)
 
 CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d @$(SOURCE_DATE_EPOCH) +"%d %B %Y")

=== debian/watch ===
version=4
opts=mode=git,\
dversionmangle=s/0\.1\+(\d{8})git([a-f0-9]{7})/0\.0~git$1\.$2/,\
oversionmangle=s/0\.0~git(\d{8})\.([a-f0-9]{7})$/0\.1\+$1git$2/ \
https://github.com/cseed/arachne-pnr.git \
HEAD debian uupdate

## arachne-pnr 0.1+20190728gitc40fb22

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 endif
 
 # clang only: -Wglobal-constructors
-CXXFLAGS += -I$(SRC) -std=c++11 $(OPTDEBUGFLAGS) -Wall -Wshadow -Wsign-compare -Werror
+CXXFLAGS += -I$(SRC) -std=c++11 $(OPTDEBUGFLAGS) -Wall -Wshadow -Wsign-compare
 
 ifeq ($(detected_OS),GNU)           # GNU Hurd
 	LIBS = -lm -ldl
@@ -31,7 +31,7 @@
 # Cross-compile logic
 HOST_CC ?= $(CC)
 HOST_CXX ?= $(CXX)
-HOST_CXXFLAGS += -I$(SRC) -std=c++11 $(OPTDEBUGFLAGS) -Wall -Wshadow -Wsign-compare -Werror
+HOST_CXXFLAGS += -I$(SRC) -std=c++11 $(OPTDEBUGFLAGS) -Wall -Wshadow -Wsign-compare
 HOST_LIBS ?= $(LIBS)
 
 IS_CROSS_COMPILING = no

=== examples/rot/Makefile ===

rot.bin: rot.v rot.pcf
	yosys -q -p "synth_ice40 -blif rot.blif" rot.v
	../../bin/arachne-pnr -p rot.pcf rot.blif -o rot.txt
	icebox_explain rot.txt > rot.ex
	icepack rot.txt rot.bin

clean:
	rm -f rot.blif rot.txt rot.ex rot.bin

=== debian/changelog ===
arachne-pnr (0.1+20190728gitc40fb22-2) unstable; urgency=medium

  * Team Upload.
  * Drop too strict version comparison
    - This is pulled fro corresponding fix in ubuntu
    - Thank you, Matthias Klose (Closes: #982852)
  * Mark autopkgtest as superficial (Closes: #974438)
  * Enable HOST_CC and HOST_CXX from dpkg buildflags
    - Upstream fixed Makefile in the new upstream version
    - Thank you, Helmut Grohne (Closes: #952971)
  * Declare compliance with policy 4.5.1

 -- Nilesh Patra <npatra974@gmail.com>  Mon, 15 Feb 2021 19:21:33 +0530

arachne-pnr (0.1+20190728gitc40fb22-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * d/patches/0003-Not-Werror.patch was accepted upstream
  * d/control:
    - Standards to 4.5.0 - no changes required
    - Rules-Requires-Root: no
    - Homepage now https://github.com/YosysHQ/arachne-pnr
    - debhelper-compat (13)
  * d/copyright: adjusted source URL
  * d/u/metadata: removed entry 'Name' redundant to d/copyright

 -- Steffen Moeller <moeller@debian.org>  Wed, 02 Sep 2020 16:38:56 +0200

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,14 @@
 Uploaders: Ruben Undheim <ruben.undheim@gmail.com>
 Section: electronics
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 13),
                fpga-icestorm-chipdb (>= 0~20181109git9671b76),
                txt2man
-Standards-Version: 4.2.1
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/science-team/arachne-pnr
 Vcs-Git: https://salsa.debian.org/science-team/arachne-pnr.git
-Homepage: https://github.com/cseed/arachne-pnr
+Homepage: https://github.com/YosysHQ/arachne-pnr
+Rules-Requires-Root: no
 
 Package: arachne-pnr-chipdb
 Architecture: all
@@ -34,6 +35,7 @@
          arachne-pnr-chipdb,
          yosys,
          fpga-icestorm
+Suggests: nextpnr
 Description: Place and route tool for iCE40 family FPGAs
  Arachne-pnr implements the place and route step of the hardware compilation
  process for FPGAs. It accepts as input a technology-mapped netlist in BLIF
@@ -45,3 +47,5 @@
  .
  Together, Yosys, arachne-pnr and IceStorm provide an fully open-source
  Verilog-to-bistream tool chain for iCE40 1K and 8K FPGA development.
+ .
+ The authors of arachne-pnr have now prepared its successor 'nextpnr'.

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,10 @@
 #export DH_VERBOSE = 1
 
 include /usr/share/dpkg/pkg-info.mk
+include /usr/share/dpkg/buildtools.mk
+
+export HOST_CC ?= $(CC_FOR_BUILD)
+export HOST_CXX ?= $(CXX_FOR_BUILD)
 
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

=== debian/watch ===
version=4
opts=mode=git,\
dversionmangle=s/0\.1\+(\d{8})git([a-f0-9]{7})/0\.0~git$1\.$2/,\
oversionmangle=s/0\.0~git(\d{8})\.([a-f0-9]{7})$/0\.1\+$1git$2/ \
https://github.com/YosysHQ/arachne-pnr \
HEAD debian uupdate

#https://github.com/cseed/arachne-pnr.git \
